function onScriptLoad( )
{
	// Load the class
	dofile("sunshine/sunshine.nut");

	// Load into array 'MyVehicles'
	SunshineAutos.LoadDatabase("sunshine/sunshine.db");

	print( "=== Loaded Sunshine Auto's v1.1 - By rulk ===" );
}

function onPlayerPart( player, reason )
{
    	// Remember to save regularly
	SunshineAutos.SaveDatabase("sunshine/sunshine.db");    
}


// NOTE: The third parameter of the OnPlayerCommand event, 
//	 is labled 'text' in this example script.
function onPlayerCommand( player, cmd, text )
{
	if ( cmd == "car" )
	{
		// Lets first establish if your in a vehicle
		if ( player.Vehicle == null ) MessagePlayer( "Error: you are not in a vehicle.", player );
		else
		{
			// OK, we're in a vehicle, lets get it's instance into a variable.
			local vehicle = player.Vehicle;

			// Now we can build our output string.
			local output = @"Model: " 	+	MyVehicles[ vehicle.ID ].VehicleModel 			+ " - "  +
  					"ID: "		+	MyVehicles[ vehicle.ID ].VehicleID 			+ " - "  +
					"Type: "	+	MyVehicles[ vehicle.ID ].VehicleCat   			+ " - "  + 
					"Price: "	+	MyVehicles[ vehicle.ID ].VehiclePrice;


			// Using the Triadic operator, establish if the vehicle is purchased or shared, by checking the length of it's value.
			local 
			      IsPurchased 	=  	MyVehicles[ vehicle.ID ].IsPurchased.len() > 0 ? MyVehicles[ vehicle.ID ].IsPurchased  : "For Sale",
			      IsShared 		= 	MyVehicles[ vehicle.ID ].IsShared.len()    > 0 ? MyVehicles[ vehicle.ID ].IsShared     : "Not Shared";


			// Add the above conditions to our output string.
			output = output + " - " + "Owner: " + IsPurchased + " - " + "Sharer: " + IsShared;

			// Display our output in-game.
			PrivMessage( player, output );
		}
	}
	else if ( cmd == "forsale" )
	{
		// Call the forsale algorythym
		Message( "Forsale: " + SunshineAutos.ForSale() );
	}
	else if ( cmd == "mycars" )
	{
		// Call the MyCars algorythym
		PrivMessage( player, SunshineAutos.MyCars( player.Name ) );
	}

	else if ( cmd == "sharedcars" )
	{
		// Call the SharedCars algorythym
		PrivMessage( player, SunshineAutos.SharedCars( player.Name ) );
	}
	else if ( cmd == "buycar" )
	{
		// Lets first establish if your in a vehicle
		if ( player.Vehicle == null ) MessagePlayer( "Error: you are not in a vehicle.", player );
		else
		{
			// OK, we're in a vehicle, lets get it's instance into a variable.
			local vehicle = player.Vehicle;

			// Put the IsPurchased property into a variable, so we can access squirrel's VM built in manipulation functions for that data type.
			local val = MyVehicles[ vehicle.ID ].IsPurchased;

			// First, check its an empty value ( it's available to buy )
			if ( ( val == null ) || ( val.len() == 0 ) )
			{
				// Then Set the value in our array.
				MyVehicles[ vehicle.ID ].IsPurchased = player.Name;

				// Display whats going on.
				MessagePlayer( "You have now purchased this vehicle.", player );
			}

			// It's got a value, and is purchased, therefore, not avilable to buy
			else MessagePlayer( "Error: Vehicle not avilable to purchase.", player );
		}
	}
	else if ( cmd == "sellcar" )
	{
		// A few paremeter checks before we can transfer the vehicle.
		if ( !text ) MessagePlayer( "Error: Missing paremeter - Name/ID", player );
		else if ( !FindPlayer( text ) ) MessagePlayer( "Error: " + text + " is not online.", player );
		else if ( player.Vehicle == null ) MessagePlayer( "Error: you are not in a vehicle.", player );
		else
		{
			// OK, we're in a vehicle, lets get it's instance into a variable.
			local vehicle = player.Vehicle;

			// Put the IsPurchased property into a variable, so we can access squirrel's VM built in manipulation functions for that data type.
			local val = MyVehicles[ vehicle.ID ].IsPurchased;
		
			// First, Check they own that vehicle.
			if ( val == player.Name ) 
			{
				// Establish The player we wish to sell to and get their instance into a variable for manipulation.
				local plr = FindPlayer( text );

				// Check they are not trying to sell it to themselves.
				if ( player.Name == plr.Name ) MessagePlayer( "Error: You already own this vehicle", player );
				else
				{
					// OK, now Set the value in our array.
					MyVehicles[ vehicle.ID ].IsPurchased = plr.Name;

					// Display whats going on.
					MessagePlayer( "You have now sold this vehicle to " + plr.Name, player );
				}
			}

			// They do not own that vehicle.
			else MessagePlayer( "Error: you do not own this vehicle.", player );
		}
	}
	else if ( cmd == "sharecar" )
	{
		// A few paremeter checks before we can share the vehicle.
		if ( !text ) MessagePlayer( "Error: Missing paremeter - Name/ID", player );
		else if ( !FindPlayer( text ) ) MessagePlayer( "Error: " + text + " is not online.", player );
		else if ( player.Vehicle == null ) MessagePlayer( "Error: you are not in a vehicle.", player );
		else
		{
			// OK, we're in a vehicle, lets get it's instance into a variable.
			local vehicle = player.Vehicle;

			// Put the object properties into a variable, so we can access squirrel's VM built in manipulation functions for that data type.
			local 	
				IsPurchased 	= 	MyVehicles[ vehicle.ID ].IsPurchased,
				IsShared 	= 	MyVehicles[ vehicle.ID ].IsShared,
				VehicleModel	=	MyVehicles[ vehicle.ID ].VehicleModel,
				VehicleID	=	MyVehicles[ vehicle.ID ].VehicleID;
				
		
			// First, Check they own that vehicle.
			if ( IsPurchased == player.Name ) 
			{
				// Now, check IsShared is an empty value ( it's available to share )
				if ( ( IsShared == null ) || ( IsShared.len() == 0 ) )
				{
					// Establish The player we wish to share with, and get their instance into a variable for manipulation.
					local plr = FindPlayer( text );

					// Check they are not trying to share it with themselves.
					if ( player.Name == plr.Name ) MessagePlayer( "Error: You own this vehicle.", player );
					else
					{
						// OK, now Set the IsShared value in our array.
						MyVehicles[ vehicle.ID ].IsShared = plr.Name;

						// Display whats going on.
						MessagePlayer( "You have now shared this vehicle with " + plr.Name, player );

						// Message the new sharer.
						MessagePlayer( "You are now sharing, Model: " + VehicleModel + " - ID: " + VehicleID + " with " + player.Name, plr );
					}
				}

				// The vehicle is already shared.
				else MessagePlayer( "This vehicle is already shared with " + IsShared, player );
			}

			// They do not own that vehicle.
			else MessagePlayer( "Error: you do not own this vehicle.", player );
		}
	}
	else if ( cmd == "delshare" )
	{
		// Lets first establish if your in a vehicle
		if ( player.Vehicle == null ) MessagePlayer( "Error: you are not in a vehicle.", player );
		else
		{
			// OK, we're in a vehicle, lets get it's instance into a variable.
			local vehicle = player.Vehicle;

			// Put the object properties into a variable, so we can access squirrel's VM built in manipulation functions for that data type.
			local 	
				IsPurchased 	= 	MyVehicles[ vehicle.ID ].IsPurchased,
				IsShared 	= 	MyVehicles[ vehicle.ID ].IsShared;

			// First, Check they own that vehicle.
			if ( IsPurchased == player.Name ) 
			{
				// Now, check IsShared is not an empty value ( it's shared )
				if ( IsShared.len() > 0 )
				{
					// OK, now Set the IsShared value in our array.
					MyVehicles[ vehicle.ID ].IsShared = "";

					// Display whats going on.
					MessagePlayer( "You have now removed " + IsShared + " from sharing this vehicle.", player );
				}

				// The vehicle is not shared.
				else MessagePlayer( "Error: This vehicle is not shared with anyone.", player );
			}

			// They do not own that vehicle.
			else MessagePlayer( "Error: you do not own this vehicle.", player );
		}			
	}
	else if ( cmd == "getcar" )
	{
		// A few paremeter checks before we can get the vehicle.
		if ( !text ) MessagePlayer( "Error: Missing paremeter - Vehicle ID", player );
		else if ( !player.IsSpawned ) MessagePlayer( "Error: Please spawn first.", player );
		else
		{
			// Convert the typed 'text' to an integer
			local 
			     IsPurchased = MyVehicles[ text.tointeger() ].IsPurchased,
			     IsShared = MyVehicles[ text.tointeger() ].IsShared;

			// Establish if they own or share the vehicle
			if ( ( IsPurchased != player.Name ) && ( IsShared != player.Name ) ) MessagePlayer( "Error: you do not own or share this vehicle.", player );
			else 
			{
				// They do, so add the vehicle to a variable
				local veh = FindVehicle( text.tointeger() );

				// and, now position it.
				veh.Pos = player.Pos; 
			}
		}
	}
}
 